# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free

Name:           apache-tika
Version:        0.7
Release:        1%{?dist}
Epoch:          0
Summary:        Tika Content Analysis Tool
License:        Apache Software License 2.0
Url:            http://tika.apache.org/
Group:          Development/Libraries
Source0:        apache-tika-0.7.tgz
# svn export http://svn.apache.org/repos/asf/tika/tags/0.7/ apache-tika-0.7
# tar czf apache-tika-0.7.tgz apache-tika-0.7/

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Patch0:         apache-tika-core-pom.patch
Patch1:         apache-tika-parsers-pom.patch
Patch2:         apache-tika-parent-pom.patch
Patch3:         apache-tika-formats-apt.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  junit
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-default-skin
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-pmd
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-shared-plugin-testing-harness
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  apache-commons-parent
BuildRequires:  apache-commons-cli
BuildRequires:  apache-commons-collections
BuildRequires:  apache-commons-compress
BuildRequires:  apache-commons-io
BuildRequires:  apache-commons-lang
BuildRequires:  apache-pdfbox
BuildRequires:  apache-poi
BuildRequires:  bouncycastle
BuildRequires:  jaxen
BuildRequires:  metadata-extractor
BuildRequires:  mockito
BuildRequires:  tagsoup
BuildRequires:  liberation-fonts

Requires:       apache-commons-cli
Requires:       apache-commons-collections
Requires:       apache-commons-compress
Requires:       apache-commons-io
Requires:       apache-commons-lang
Requires:       apache-pdfbox
Requires:       apache-poi
Requires:       bouncycastle
Requires:       metadata-extractor
Requires:       tagsoup

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5


%description
Apache Tika is a toolkit for detecting and extracting 
metadata and structured text content from various documents
using existing parser libraries. You can find the latest
release on the download page. See the Getting Started 
guide for instructions on how to start using Tika.
Tika was formerly a subproject of Apache Lucene


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q 
# remove all binary libs
#find . -name "*.jar" -exec rm -f {} \;
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3

%build
cp %{SOURCE1} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install 
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        site javadoc:javadoc


%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-tika.pom
%add_to_maven_depmap org.apache.tika tika %{version} JPP/%{name} tika
install -m 644 tika-parent/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
%add_to_maven_depmap org.apache.tika tika-parent %{version} JPP/%{name} parent
install -m 644 tika-app/target/tika-app-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/app-%{version}.jar
install -m 644 tika-app/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-app.pom
%add_to_maven_depmap org.apache.tika tika-app %{version} JPP/%{name} app
install -m 644 tika-bundle/target/tika-bundle-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle-%{version}.jar
install -m 644 tika-bundle/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-bundle.pom
%add_to_maven_depmap org.apache.tika tika-bundle %{version} JPP/%{name} bundle
install -m 644 tika-core/target/tika-core-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 tika-core/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core.pom
%add_to_maven_depmap org.apache.tika tika-core %{version} JPP/%{name} core
install -m 644 tika-parsers/target/tika-parsers-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/parsers-%{version}.jar
install -m 644 tika-parsers/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parsers.pom
%add_to_maven_depmap org.apache.tika tika-parsers %{version} JPP/%{name} parsers

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* \
    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/site/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap


%files 
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Sat Oct 02 2010 Ralph Apel <r.apel at r-apel.de> 0:0.7-1
- first JPP release

